MARTe2-components - User story #351

OPCUA
08.11.2018 11:05 - André Neto

Status: Closed Start date: 08.11.2018
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Spent time: 0.00 hour
Git branch (link): SVN commit

(link/?p=rev):
Git merge to develop
(link):
Description

Documentation, linting and coverage checked. Deployed in develop.

Implement an OPCUA interface for signals and StructuredDatal.

Source code files modified

Architecture & design review

Date of the review: //2019
Person who did the review: Andre' Neto

Version of architecture & designh document: N/A. Strategy and main ideas for implementation discussed with B. Bauvir in informal
meetings.

Result of review: N/A

List of non-conformities: N/A

Code and documentation review
Date of the review: 13/07/2020

Person who did the review: Didac Magrifia

Result of review: PASS

List of non-conformities:

Headers

OK: All headers are correctly formatted
OK: no errors found.

Possible Memory Issues:

e OPCUACIientl
o GetReferences:
= missing check to number of nodes before accessing bReq.nodesToBrowse
¢ OPCUACIientMethod, OPCUACIientRead, OPCUACIientWrite
o Destructor (of three mentioned classes):
= missing check if tempVariant and monitoredNodes are allocated before deleting them
o GetExtensionObjectByteString (of three mentioned classes):
= missing check if index is within range before accessing entryTypes and entryArrayElements
= missing check if valueMemories[nodeCounter] is not null before accessing
= missing check if tempDataPtr[nOfBytes] is not null before accessing
SetServiceRequest (of three mentioned classes):
= missing delete bReqg.nodesToBrowse
OPCUACIientMethod::SetObjectRequest
= missing delete tempStringnodeld after its allocation in OPCUACIientl::GetReferences
= missing delete ombReq.nodesToBrowse
OPCUACIientMethod::SetMethodRequest
= missing delete tempStringnodeld after its allocation in OPCUACIientl::GetReferences
= missing delete mbReqg.nodesToBrowse
OPCUACIientWrite::SetWriteRequest
= missing check if writeValues[idx] is not null before accessing
¢ OPCUADSInput, OPCUADSOutput
o GetSignalMemoryBuffer (of both classes)
= missing check if signalldx is within range before accessing types and nElements
o GetStructure (of both classes)
= missing check if index is within range before accessing entryArrayElements, entryTypes, and
entryNumberOfMembers
¢ OPCUANode
o Destructor
= missing delete of settings->attr.arrayDimensions created on OPCUANode::InitArray
= missing delete of settings->attr.value.arrayDimensions created on OPCUANode::InitArray
e OPCUACIient
o MapStructuredData
= missing check if index is within range before accessing entryArrayElements, entryTypes, and entryMemberNames

(e}

o]

(o]

(e}

Documentation Improvements:

¢ Document structures in OPCUATYypes.h following Doxygen style
¢ Confirm that multiple extension objects are not supported as per OPCUADSInput/OPCUADSOutput documentation. If they are
supported, consider adding a test for this use case.

When using Complex DataType Extension, the DataSource only allows to write 1 structure. If you
need to add more signals you must add another OPCUADSInput DataSource to your real time appli
cation.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATYypes.h:45: warning: Compound
OPCUA::NodeProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATypes.h:60: warning: Compound
OPCUA::ObjectProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATypes.h:54: warning: Member
OPCUANodeSettings (typedef) of namespace OPCUA is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATypes.h:68: warning: Member
OPCUAODbjectSettings (typedef) of namespace OPCUA is not documented.

ERR:
/home/andre/Projects/MARTe2-components/Source/Components/DataSources/OPCUADataSource/OPCUACIientMethod.h:90:
warning: argument 'nodePaths' of command @param is not found in the argument list of
MARTe::OPCUACIientMethod::SetMethodRequest(const uint16 methodNamespacelndex, StreamString methodPath)

ERR:
/home/andre/Projects/MARTe2-components/Source/Components/DataSources/OPCUADataSource/OPCUACIientMethod.h:90:
warning: The following parameters of MARTe::OPCUACIientMethod::SetMethodRequest(const uint16 methodNamespacelndex,
StreamString methodPath) are not documented:

ERR:
/home/andre/Projects/MARTe2-components/Source/Components/DataSources/OPCUADataSource/OPCUACIientMethod.h:79:
warning: argument 'nodePaths' of command @param is not found in the argument list of
MARTe::OPCUACIientMethod::SetObjectRequest(const uint16 methodNamespacelndex, StreamString methodPath)

ERR:
/home/andre/Projects/MARTe2-components/Source/Components/DataSources/OPCUADataSource/OPCUACIientMethod.h:79:
warning: The following parameters of MARTe::OPCUACIlientMethod::SetObjectRequest(const uint16 methodNamespacelndex,
StreamString methodPath) are not documented:

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATYypes.h:46: warning: Member attr
(variable) of class OPCUA::NodeProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATypes.h:47: warning: Member
value (variable) of class OPCUA::NodeProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATYypes.h:48: warning: Member
nodeld (variable) of class OPCUA::NodeProperties is not documented.
ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATypes.h:49:

nodeName (variable) of class OPCUA::NodeProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/ OPCUA/OPCUATYypes.h:50:

parentNodeld (variable) of class OPCUA::NodeProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATypes.h:51:

parentReferenceNodeld (variable) of class OPCUA::NodeProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATypes.h:61:

(variable) of class OPCUA::ObjectProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATypes.h:62:

nodeld (variable) of class OPCUA::ObjectProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/ OPCUA/OPCUATypes.h:63:

nodeName (variable) of class OPCUA::ObjectProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATYypes.h:64:

parentNodeld (variable) of class OPCUA::ObjectProperties is not documented.

ERR: /home/andre/Projects/MARTe2-components/Source/Components/Interfaces/OPCUA/OPCUATypes.h:65:

parentReferenceNodeld (variable) of class OPCUA::ObjectProperties is not documented.

Refactoring Suggestions:

warning:
warning:
warning:
warning:
warning:
warning:
warning:

warning:

Member

Member

Member

Member attr

Member

Member

Member

Member

e OPCUACIientRead, OPCUACIientWrite, and OPCUACIientMethod have very similar methods that could be moved up to their

interface OPCUACIientl:
o SetServiceRequest
o GetExtensionObjectByteString

Unit test review

Date of the review: 13/07/2019

Person who did the review: Didac Magrifia
Result of coverage tests review: PASS
Result of functional tests review: PASS
Result of review: PASS

List of non-conformities:

¢ OPCUAMessageClient: coverage lower than 90% (82.9%)

¢ The mock OPCUA server used in other tests could be leveraged on OPCUACIlientMethodTest, OPCUAMessageClientTest to

check if UpdatePoint method has been called with expected parameters
e OPCUAServerTest: on Execute tests there is no check to confirm that data has been updated correctly

e OPCUACIientReadTest, OPCUACIientWriteTest: there is no check to confirm that data has been read/written correctly on

server

ERR: Test file not found: Test/Components/Interfaces/OPCUA/OPCUATypesGTest.cpp
ERR: OPCUAODbiject:IsFirstObject is not tested

ERR: OPCUAODbiject:IsObject is not tested

ERR: OPCUAODbject:SetFirst is not tested

ERR: OPCUAMessageClient:GetOPCUACIient is not tested

ERR: OPCUAMessageClient:GetServerAddress is not tested

ERR: OPCUAReferenceContainer:GetNumberOfDimensions is not tested
ERR: OPCUAReferenceContainer:GetNumberOfElements is not tested
ERR: OPCUAReferenceContainer:GetParentNodeld is not tested

ERR: OPCUAReferenceContainer:IsFirstObject is not tested

ERR: OPCUAReferenceContainer:SetNodeld is not tested

ERR: OPCUAReferenceContainer:SetNodeType is not tested

ERR: OPCUAReferenceContainer:SetNumberOfDimensions is not tested
ERR: OPCUAReferenceContainer:SetNumberOfElements is not tested
ERR: OPCUAReferenceContainer:SetParent is not tested

ERR: OPCUANode:IsNode is not tested

ERR: OPCUAServer:GetCPUMask is not tested

ERR: OPCUAServer:GetPort is not tested

ERR: OPCUAServer:GetRunning is not tested

ERR: OPCUAServer:GetStackSize is not tested

ERR: OPCUAServer:SetRunning is not tested
ERR:

ERR

ERR

ERR

ERR

ERR

ERR

ERR

ERR

ERR:
ERR:
ERR:
ERR:
ERR:

OPCUACIlientMethod:GetMonitoredNodes is not tested

: OPCUACIientRead:GetMonitoredNodes is not tested
ERR:
ERR:

OPCUACIientWrite:GetMonitoredNodes is not tested
OPCUACIientl:GetDataPtr is not tested

: OPCUACIientl:GetExtensionObjectByteString is not tested
ERR:
ERR:

OPCUACIientl:GetNumberOfNodes is not tested
OPCUACIientl:GetServerAddress is not tested

: OPCUACIientl:GetValueMemories is not tested
ERR:

OPCUACIientl:SetServiceRequest is not tested

: OPCUADSOutput:AllocateMemory is not tested
ERR:
ERR:

OPCUADSOutput:GetBrokerName is not tested
OPCUADSOutput:GetOPCUACIient is not tested

: OPCUADSOutput:GetServerAddress is not tested
ERR:
ERR:

OPCUADSOutput:GetSignalMemoryBuffer is not tested
OPCUADSOutput:PrepareNextState is not tested

: OPCUADSOutput:Synchronise is not tested
ERR:

OPCUADSInput:AllocateMemory is not tested

: OPCUADSInput:GetBrokerName is not tested
ERR:
ERR:

OPCUADSInput:GetOPCUACIient is not tested
OPCUADSInput:GetServerAddress is not tested

: OPCUADSInput:GetSignalMemoryBuffer is not tested
ERR:

OPCUADSInput:PrepareNextState is not tested

DataSources/OPCUADataSource/OPCUACIientl.cpp: insufficient line coverage: (87.0 % < 90.0 %)
DataSources/OPCUADataS.../OPCUACIientMethod.cpp: insufficient line coverage: (85.5 % < 90.0 %)
DataSources/OPCUADataSource/OPCUACIlientRead.cpp: insufficient line coverage: (83.1 % < 90.0 %)
DataSources/OPCUADataS...e/OPCUACIientWrite.cpp: insufficient line coverage: (84.5 % < 90.0 %)
Interfaces/OPCUA/OPCUAMessageClient.cpp: insufficient line coverage: (78.9 % < 90.0 %)

GTest report

7777777 ] Global test environment tear—-down
=======] 154 tests from 11 test cases ran. (135431 ms total)

[ PASSED ] 154 tests.

History

#1 - 12.06.2019 11:29 - André Neto

- Status changed from Code: Impl to Code: Rev

#2-12.06.2019 11:29 - André Neto

- Assignee changed from Luca Porzio to André Neto

#3 - 14.06.2019 18:08 - André Neto

- Status changed from Code: Rev to Unit: Rev

#4 - 14.06.2019 18:09 - André Neto

- Status changed from Unit: Rev to Closed

- Description updated

#5 - 16.12.2019 15:24 - André Neto

- Description updated

- Status changed from Closed to Code: Rev

- Assignee changed from André Neto to Giuseppe Ferro

#6 - 29.01.2020 12:23 - André Neto

- Assignee deleted (Giuseppe Ferro)

#7 - 11.03.2020 10:20 - André Neto

- Assignee set to Didac Magrina
#8 - 22.04.2020 10:49 - André Neto
- Status changed from Code: Rev to Code: Impl

#9 - 22.04.2020 10:50 - André Neto

- Assignee changed from Didac Magrina to Luca Porzio

#10 - 01.07.2020 09:51 - André Neto
- Status changed from Code: Impl to Code: Rev

#11 - 13.07.2020 15:35 - Didac Magrina
- Description updated

#12 - 15.07.2020 11:22 - Didac Magrina

Branch #351_OPCUA-Review has not been merged yet into develop. A simulation has been performed on branch
develop_merge_#351_OPCUA-Review, it required to:

e Fix conflicts accepting version from #351_OPCUA-Review. Conflicts are due to some commits on develop modified OPCUA files but were not

present on #351_OPCUA-Review. See commits between 489e09d6 and 0b7200c7
¢ Remove tests that remained from develop branch but were removed on #351_OPCUA-Review. See commit 33ebbd5c

#13 - 23.07.2020 09:46 - André Neto

- Status changed from Code: Rev to Unit: Rev

#14 - 23.07.2020 09:47 - André Neto

- Assignee changed from Luca Porzio to André Neto

#15 - 28.09.2020 08:12 - André Neto

- Description updated

#16 - 28.09.2020 08:12 - André Neto
- Status changed from Unit: Rev to Closed

- Assignee deleted (André Neto)

QA good enough. Merged into develop and user-stories to improve QA will be added.

#17 - 21.12.2020 16:24 - André Neto

- Description updated
